# main robot-control loop
while True:

    # S = sense: what do my sensors tell me?
    ALL_SENSORS = robot.GetAllData()
    (x,y,thr,(R,stalled),timestamp,(rx,ry,rthr)) = ALL_SENSORS
    thd = thr*180.0/math.pi   # robot's belief - also x,y,thr
    rthd = rthr*180.0/math.pi # robot's unknown real pose - also rx,ry,rthr
    # in general, using the "real" values is "cheating," since
    # they would not be known to a wandering robot



    # P = plan

    # figure out what state to be in
    # print a message if we are changing state
    if state == GoForward:
        if min(frontThree(R)) < FRONT_THRESH:
            state = TurnRight90
            print 'I am changing to state TurnRight90'
            desiredAngled = thd - 93
            angleWindowd = 3

    elif state == TurnRight90:
            if angleCompare( thd, desiredAngled, angleWindowd ):
                state = GoForward
                print 'I am changing to state GoForward'

    else:
        print 'I\'m lost and so I\'m stopping'
        state = Stop

    # set the velocities appropriate to the state we are in
    v_cmpersec =  velocities[state][0]
    v_degpersec = velocities[state][1]


    # A = act: send velocities to the robot only if they've changed
    if v_cmpersec != v_cm_old or v_degpersec != v_deg_old:
        robot.Go(v_cmpersec, v_degpersec)
        v_cm_old = v_cmpersec
        v_deg_old = v_degpersec


    # visualize: prepare data for the graphics window (robot-depedent)
    #   there is probably a cleverer python way to do this...

    # the next line turns off the orange range sensor bars for now...
    #R = [0,0,0,0,0,0,0]
    msg = 'rB_%.2f_%.2f_%.2f_%.2f_%.2f_%.2f_%.2f_%.2f_%.2f_%.2f\
                    _%.2f_%.2f_%.2f_%.2f_%.2f_%.2f_%.2f_%.2f_%.2f_%.2f' % \
          (x+25,y-10,thr+0.7,R[0],R[1],R[2],R[3],R[4],R[5],R[6],\
                    rx,ry,rthr,0.0,0.0,0.0,0.0,0.0,0.0,0.0)
                    #rx,ry,rthr,R[0],R[1],R[2],R[3],R[4],R[5],R[6])
    retmsg = vc.exchMessage(msg)

    # check the time
    nowtime = time.clock()
    if nowtime - lasttime > 0.5:
        thr1, dist, thr2 = computeTotalRobotMotion(lastUpdateLoc,(x,y,thr))
        PL = moveParticles( PL, thr1, dist, thr2 )
        PL = updateParticles( PL, robot, ALL_SENSORS )
        vc.sendParticles( PL )
        lastUpdateLoc = (x,y,thr)  # reset where we last updated...
        lasttime = nowtime

    # any keypresses to handle?
    if retmsg == 'pose': # when the robot is reset
        msgToProcess = retmsg
        #print msgToProcess
        msglist = msgToProcess.split('_')
        if msglist[0] == 'pose':
            newx = float(msglist[1])
            newy = float(msglist[2])
            newthr = float(msglist[3])
            robot.SetOdometry(newx, newy, newthr)

    elif retmsg[0:5] == 'char:':
        c = retmsg[5:]
        #print 'I saw a', c
        if c == 'r':
            print 'resetting random particles...'
            # update the particles here...
            PL = randomParticleStart(x,y,thr)
            # these lines will send the message to redraw them...
            vc.sendParticles( PL )
            # remember where the robot was when this reset occurred
            lastUpdateLoc = (x,y,thr)
        elif c == 'm':
            print 'moving particles...'
            thr1, dist, thr2 = computeTotalRobotMotion(lastUpdateLoc,(x,y,thr))
            #print 'thd1 is', math.degrees(thr1)
            #print 'dist is', dist
            #print 'thd2 is', math.degrees(thr2)
            PL = moveParticles( PL, thr1, dist, thr2 )
            # these lines will send the message to redraw them...
            vc.sendParticles( PL )
            # remember where the robot was when this motion occurred
            lastUpdateLoc = (x,y,thr)
        elif c == 'u':
            print 'updating population...'
            PL = updateParticles( PL, robot, ALL_SENSORS )
            print 'len of PL is', len(PL)
            vc.sendParticles( PL )

    # reference vs value exercise...
    # noise exercise = "reasonable model"?
    # hits - how to use them - exceptions?

        # feel free to add responses to your own button presses, if you like!